'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var colors = [{ name: 'red', code: 9 }, { name: 'orange', code: 208 }, { name: 'yellow', code: 11 }, { name: 'green', code: 10 }, { name: 'blue', code: 12 }, { name: 'indigo', code: 54 }, { name: 'violet', code: 93 }];

var C = function C(index) {
  return function (str) {
    return '\x1B[38;5;' + colors[index].code + 'm' + str + '\x1B[0m';
  };
};

var applyColors = function applyColors(rainbow) {
  var applyByOrder = function applyByOrder(base, char) {
    if (char === '-') return C(base)(char);else if (char === '_') return C(base + 1)(char);
    return char;
  };

  return rainbow.map(function (line, r) {
    return line.split('').map(function (char) {
      return applyByOrder(r * 2, char);
    }).join('');
  });
};

exports.default = applyColors;
//# sourceMappingURL=colors.js.map