'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _colors = require('./colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function nyanProgress() {
  var stream = _readline2.default.createInterface({
    input: process.stdin,
    output: process.stdout
  });

  var nyan = {
    frames: [' ,------,\n |   /\\_/\\\n~|__( o .o)\n   ""  ""   ', ' ,------,\n |   /\\_/\\\n~|__( o .o)\n  ""  ""    '],
    complete: ' ,------,\n |   /\\_/\\\n~|__( ^ .^)\n   ""  ""   ',
    error: ' ,------,\n |   /\\_/\\\n~|__( x .x)\n   ""  ""   '
  };

  var appendVertical = function appendVertical(linesOfStr) {
    for (var _len = arguments.length, appendants = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      appendants[_key - 1] = arguments[_key];
    }

    var result = linesOfStr.slice();

    for (var line = 0; line < result.length; line += 1) {
      for (var a = 0; a < appendants.length; a += 1) {
        result[line] += appendants[a][line];
      }
    }

    return result;
  };

  var tick = 0;

  return {
    animation: 0,
    isComplete: false,
    rainbow: '',
    timeStart: 0,

    start: function start() {
      var _this = this;

      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments[1];

      this.curr = options.curr || 0;
      this.total = options.total || 100;
      this.width = options.width || 20;
      this.renderThrottle = options.renderThrottle || 500;
      this.message = _extends({
        downloading: ['Nyaning.  ', 'Nyaning.. ', 'Nyaning...'],
        finished: 'Nyaned',
        error: 'Something nyan wrong...'
      }, options.message);
      this.callback = callback;

      this.isComplete = false;

      this.rainbow = ['_-', '-_', '_-', '- '].map(function (line) {
        return line.repeat(Math.ceil((_this.width + 1) / 2)).substring(0, _this.width + 1);
      });

      _readline2.default.cursorTo(stream, 0, 0);
      _readline2.default.clearScreenDown(stream);

      return new Promise(function (resolve) {
        _this.interupt = _this.terminate.bind(_this);
        _this.timeStart = Date.now();
        _this.animation = setInterval(function () {
          if (_this.curr >= _this.total) {
            resolve(_this.terminate());
            return;
          }

          _this.animate();
        }, _this.renderThrottle);
      });
    },
    animate: function animate() {
      if (tick) {
        _readline2.default.cursorTo(stream, 0, 0);
      }

      var cat = nyan.frames[tick % nyan.frames.length].split('\n');
      var paint = this.draw(cat, this.message.downloading);

      stream.write(paint.join('\n') + '\n');

      tick += 1;
    },
    draw: function draw(cat, messages) {
      var portion = this.curr / this.total;
      var percent = Math.floor(portion * 100 > 100 ? 100 : portion * 100).toString();
      var len = Math.floor((portion > 1 ? 1 : portion) * this.width);
      var flag = tick % nyan.frames.length;
      var rainbow = this.rainbow.map(function (line) {
        return line.substring(flag, flag + len);
      });

      var paint = appendVertical([' ', ' ', ' ', ' '], (0, _colors2.default)(rainbow), cat);

      var message = Array.isArray(messages) ? messages[tick % messages.length] : messages;
      var bar = '[' + '='.repeat(len) + ' '.repeat(this.width - len) + '] ' + percent + '% ' + message;
      paint.push(bar);

      return paint;
    },
    tick: function tick() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

      this.curr += value;

      return this;
    },
    terminate: function terminate() {
      clearInterval(this.animation);
      this.animation = 0;
      var timeElappsed = (Date.now() - this.timeStart) / 1000;

      _readline2.default.moveCursor(stream, 0, -1);
      _readline2.default.clearLine(stream, 0);
      _readline2.default.cursorTo(stream, 0, 0);

      var isFinished = this.curr >= this.total;
      var cat = nyan[isFinished ? 'complete' : 'error'].split('\n');
      var message = isFinished ? this.message.finished : this.message.error;
      var paint = this.draw(cat, message);

      if (isFinished) {
        paint[paint.length - 1] += ' in ' + timeElappsed + 's.\n';
      }

      stream.write(paint.join('\n') + '\n');
      stream.close();

      this.isComplete = true;

      if (typeof this.callback === 'function') {
        this.callback.call();
      }
    }
  };
}

exports.default = nyanProgress;

module.exports = nyanProgress;
//# sourceMappingURL=index.js.map